using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class GEN_Monedas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_GEN_Monedas_Listado_Modelo> g_lst_INTERNO_GEN_Monedas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Monedas).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................


                if ((g_lst_INTERNO_GEN_Monedas_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Monedas_Listado_Modelo.Count() > 0))
                {
                    lst_GEN = g_lst_INTERNO_GEN_Monedas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_GEN;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Monedas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_GEN_Monedas_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Monedas_Listado_Modelo.Count() > 0))
                {
                    dnm_GEN = g_lst_INTERNO_GEN_Monedas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_GEN;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.id) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.id) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.moneda) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.moneda) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.descripcion) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.descripcion) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.textoFin) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.textoFin) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.redondeoPrecio) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.redondeoPrecio) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.redondeoImporte) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.redondeoImporte) + "," +
                          nameof(INTERNO_GEN_Monedas_Listado_Modelo.numero) + " = " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.numero) +
                      " FROM " + nameof(GEN_Monedas) +
                      " WHERE " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.fechaBorrado) + " IS null AND " +
                              (
                                _lng_id > -1 
                                ? nameof(GEN_Monedas) + "." + (nameof(GEN_Monedas.id) + "=@id") 
                                : "1 = 1"
                              );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_GEN_Monedas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Monedas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_GEN_Monedas_Listado_Modelo g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Monedas).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3 != null)
                {
                    dnm_GEN = g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_GEN;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Monedas).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3 != null)
                {
                    dnm_GEN = g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_GEN;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                  " SELECT distinct " +
                      nameof(INTERNO_GEN_Monedas_Listado_Modelo.id) + " = " + nameof(GEN_Monedas.id) + "," +
                      nameof(INTERNO_GEN_Monedas_Listado_Modelo.moneda) + " = " + nameof(GEN_Monedas.moneda) + "," +
                      nameof(INTERNO_GEN_Monedas_Listado_Modelo.descripcion) + " = " + nameof(GEN_Monedas.descripcion) +
              " FROM " + nameof(GEN_Monedas) +
              " WHERE " + nameof(GEN_Monedas.fechaBorrado) + " IS null AND " +
                      (
                       (_lng_id > -1)
                         ? (nameof(GEN_Monedas.id) + " = " + _lng_id)
                         : (
                              //Filtrar por Codigo
                              (_str_CampoBusqueda.Equals(nameof(GEN_Monedas.moneda)))
                                  ? (nameof(GEN_Monedas.moneda) + "=@Filtro")
                                  //Filtrar por Descripcion
                                  : (nameof(GEN_Monedas.descripcion) + "=@Filtro")
                          )
                      );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_GEN_Monedas_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Monedas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .........................................................
                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_GEN_Monedas_Modelo.id) + " = " + nameof(GEN_Monedas.id) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.moneda) + " = " + nameof(GEN_Monedas.moneda) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.descripcion) + " = " + nameof(GEN_Monedas.descripcion) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.textoFin) + " = " + nameof(GEN_Monedas.textoFin) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.redondeoPrecio) + " = " + nameof(GEN_Monedas.redondeoPrecio) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.redondeoImporte) + " = " + nameof(GEN_Monedas.redondeoImporte) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.fechaBorrado) + " = " + nameof(GEN_Monedas.fechaBorrado) + "," +
                       nameof(INTERNO_GEN_Monedas_Modelo.numero) + " = " + nameof(GEN_Monedas.numero) +
               " FROM " + nameof(GEN_Monedas) +
               " WHERE " + nameof(GEN_Monedas.fechaBorrado) + " IS null AND " +
                           nameof(GEN_Monedas.id) + "=@id ";
                // .....................................................................

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Monedas_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if(g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //GEN_MonedasHistoricos ##########################################################################################
                    ThreadStart obj_ThreadStart_MONEDAHISTORICO = new ThreadStart(Obtener_MonedaHistorico_Modelo_Obtener);
                    Thread obj_Thread_MONEDAHISTORICO = new Thread(obj_ThreadStart_MONEDAHISTORICO);
                    obj_Thread_MONEDAHISTORICO.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_MonedaHistorico_Modelo_Obtener()
        {
            try
            {
                GEN_MonedasHistoricos_Datos obj_GEN_MonedasHistoricos_Datos = new GEN_MonedasHistoricos_Datos();
                g_dnm_Modelo_Obtener.MonedasHistoricos = obj_GEN_MonedasHistoricos_Datos.Obtener_MonedasHistoricos_PorMoneda(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private GEN_Monedas g_mdl_GEN_Monedas = null;
        public GEN_Monedas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(GEN_Monedas) + "." + nameof(GEN_Monedas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }
            return g_mdl_GEN_Monedas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                

                //Rellenar el Modelo
                g_mdl_GEN_Monedas = obj_Exferia_Entities.Database.SqlQuery<GEN_Monedas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<GEN_Monedas> g_lst_GEN_Monedas = null;

        public List<GEN_Monedas> Obtener_ModeloListado_Por_Ids(List<long> _lst_ids)
        {
            try
            {
                if (_lst_ids!=null && _lst_ids.Count>0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(GEN_Monedas),
                                                                                              nameof(GEN_Monedas.id),
                                                                                              G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                              _lst_ids);
                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                    " WHERE " +
                                        str_Filtros_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_GEN_Monedas;
        }
        #region Ejecutar Consulta
       
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                

                //Rellenar el listado
                g_lst_GEN_Monedas = obj_Exferia_Entities.Database.SqlQuery<GEN_Monedas>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(GEN_Monedas.id) + " , " +
                    nameof(GEN_Monedas.moneda) + " , " +
                    nameof(GEN_Monedas.descripcion) + " , " +
                    nameof(GEN_Monedas.textoFin) + " , " +
                    nameof(GEN_Monedas.redondeoPrecio) + " , " +
                    nameof(GEN_Monedas.redondeoImporte) + " , " +
                    nameof(GEN_Monedas.fechaBorrado) + " , " +
                    nameof(GEN_Monedas.numero) +
                " FROM " + nameof(GEN_Monedas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GEN_Monedas mdl_GEN_Monedas_AGrabar = (GEN_Monedas)_mdl_obj;
                GEN_Monedas mdl_GEN_Monedas_DatosViejos = new GEN_Monedas();

                // Ver si existe ######################################################################
                GEN_Monedas mdl_GEN_Monedas_Final = Obtener_Modelo_Por_Id(mdl_GEN_Monedas_AGrabar.id);
                //######################################################################################

                if (mdl_GEN_Monedas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Monedas_Final, mdl_GEN_Monedas_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Monedas_AGrabar, mdl_GEN_Monedas_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(GEN_Monedas) +
                                           " SET " +
                                               nameof(GEN_Monedas.moneda) + "=@moneda," +
                                               nameof(GEN_Monedas.descripcion) + "=@descripcion," +
                                               nameof(GEN_Monedas.textoFin) + "=@textoFin," +
                                               nameof(GEN_Monedas.redondeoPrecio) + "=@redondeoPrecio," +
                                               nameof(GEN_Monedas.redondeoImporte) + "=@redondeoImporte," +
                                               nameof(GEN_Monedas.fechaBorrado) + "=@fechaBorrado, " +
                                               nameof(GEN_Monedas.numero) + "=@numero " +
                                           " WHERE " +
                                               nameof(GEN_Monedas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@moneda",  mdl_GEN_Monedas_Final.moneda),
                        new SqlParameter("@descripcion",  mdl_GEN_Monedas_Final.descripcion),
                        new SqlParameter("@textoFin",  mdl_GEN_Monedas_Final.textoFin),
                        new SqlParameter("@redondeoPrecio",  mdl_GEN_Monedas_Final.redondeoPrecio),
                        new SqlParameter("@redondeoImporte",  mdl_GEN_Monedas_Final.redondeoImporte),
                        mdl_GEN_Monedas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_Monedas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_GEN_Monedas_Final.numero!=null
                            ?   new SqlParameter("@numero", mdl_GEN_Monedas_Final.numero)
                            :   new SqlParameter("@numero",  DBNull.Value),
                        new SqlParameter("@id",  mdl_GEN_Monedas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_GEN_Monedas_Final.id;
                }
                else
                {
                    mdl_GEN_Monedas_Final = new GEN_Monedas();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Monedas_AGrabar, mdl_GEN_Monedas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GEN_Monedas) +
                                                " (" +
                                                        nameof(GEN_Monedas.moneda) + "," +
                                                        nameof(GEN_Monedas.descripcion) + "," +
                                                        nameof(GEN_Monedas.textoFin) + "," +
                                                        nameof(GEN_Monedas.redondeoImporte) + "," +
                                                        nameof(GEN_Monedas.redondeoPrecio) + "," +
                                                        nameof(GEN_Monedas.fechaBorrado) + "," +
                                                        nameof(GEN_Monedas.numero) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(GEN_Monedas.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@moneda," +
                                                    "@descripcion," +
                                                    "@textoFin," +
                                                    "@redondeoImporte," +
                                                    "@redondeoPrecio," +
                                                    "@fechaBorrado," +
                                                    "@numero" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@moneda",  mdl_GEN_Monedas_Final.moneda),
                        new SqlParameter("@descripcion",  mdl_GEN_Monedas_Final.descripcion),
                        new SqlParameter("@textoFin",  mdl_GEN_Monedas_Final.textoFin),
                        new SqlParameter("@redondeoPrecio",  mdl_GEN_Monedas_Final.redondeoPrecio),
                        new SqlParameter("@redondeoImporte",  mdl_GEN_Monedas_Final.redondeoImporte),
                        mdl_GEN_Monedas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_GEN_Monedas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_GEN_Monedas_Final.numero!=null
                            ?   new SqlParameter("@numero", mdl_GEN_Monedas_Final.numero)
                            :   new SqlParameter("@numero",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Monedas), mdl_GEN_Monedas_DatosViejos, mdl_GEN_Monedas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GEN_Monedas mdl_GEN_Monedas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if(mdl_GEN_Monedas_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_Monedas) +
                                                " SET " +
                                                nameof(GEN_Monedas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(GEN_Monedas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Monedas), null, mdl_GEN_Monedas_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                    
                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id; 
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Monedas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}

